<template>
  <div class="max-big-box">
    <div class="big-max-box">
      <!--操作按钮-->
      <div class="top-box">
        <div class="input-box">
          <input class="search-input" v-model="inputData" type="text" placeholder="请输入物资名称关键字进行查询">
          <div class="dropdown-box" v-for="(item,index) in downList" :key="index">
            <p class="dropdown-left-title">{{item.name}}：</p>
            <div class="dropdown-right-box cursor_pointer"
                 @mouseenter="dropdownClickOpen(index,'1')" @mouseleave="dropdownClickOpen(index,'2')">
              <p class="dropdown-text">{{downList[index].downText}}</p>
              <div class="dropdown-for-max" v-if="downList[index].downType">
                <p v-for="(item,indexTwo) in downList[index].list" :key="indexTwo"
                   :class="{'color-A':downList[index].mouseColor == item}"
                   @mouseenter="colorTypeEnter(index,item)" @mouseleave="colorTypeLeave(index)"
                   @click="dropdownClick(index,item)">{{item}}</p>
              </div>
            </div>
          </div>
          <div class="button-box cursor_pointer" @click="clickQuery">
            <img src="~@/assets/images/icon_27.png">
            <p class="cursor_pointer">查询</p>
          </div>
        </div>
      </div>
      <!--表格-->
      <div class="table-box">
        <el-table
          ref="multipleTable"
          :row-key="getRowKey"
          :data="tableData"
          tooltip-effect="dark"
          style="width: 100%">
          <el-table-column
            type="index"
            :index="indexMethod"
            label="序号"
            width="91">
          </el-table-column>
          <el-table-column
            prop="organizationName"
            label="单位名称"
            width="151">
          </el-table-column>
          <el-table-column
            prop="repertoryName"
            label="仓库名称"
            width="162">
          </el-table-column>
          <el-table-column
            prop="materialName"
            label="物资名称"
            width="131">
          </el-table-column>
          <el-table-column
            prop="unit"
            label="单位"
            width="92">
          </el-table-column>
          <el-table-column
            prop="bigTypeName"
            label="类型(大类)"
            width="147">
          </el-table-column>
          <el-table-column
            prop="SmallTypeName"
            label="类型(小类)"
            width="147">
          </el-table-column>
          <el-table-column
            prop="putNum"
            label="入库数量"
            width="155">
          </el-table-column>
          <el-table-column
            prop="outNum"
            label="出库数量"
            width="155">
          </el-table-column>
          <el-table-column
            prop="stockNum"
            label="库存数量"
            width="155">
            <template slot-scope="scope">
              <p :class="{'colorA':scope.row.isWarning==1&&scope.row.stockNum<scope.row.stockWarning}">{{ scope.row.stockNum }}</p>
            </template>
          </el-table-column>
          <el-table-column
            prop="stockWarning"
            label="库存预警值"
            width="155">
          </el-table-column>
          <el-table-column
            prop="isWarning"
            label="是否预警"
            width="169">
            <template slot-scope="scope">
              <p :class="{'colorA':scope.row.isWarning==1}">{{ scope.row.isWarning==1?"是":"否" }}</p>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <el-pagination
        background
        @current-change="handleCurrentChange"
        layout="prev, pager, next"
        :current-page="currentPage"
        :page-size="pagesize"
        :total="total">
      </el-pagination>
    </div>
  </div>
</template>

<script>
  import { listOrganization,typeBig,typeSmall,statisticsAnalysisStocklistList } from '@/api/userApi'
  export default {
    name: "inventoryAnalysis",//库存分析
    data () {
      return {
        inputData:"",
        //表格限制
        pagesize: 8,
        currentPage:1,
        //列表总数
        total:0,
        /*数据*/
        tableData:[],
        //下拉框
        downList:[
          {
            name:"仓库名称",
            downType:false,
            downText:"全部",
            mouseColor:"",
            list:[],
            idType:[],
          },
          {
            name:"类型(大类)",
            downType:false,
            downText:"全部",
            mouseColor:"",
            list:[],
            idType:[],
          },
          {
            name:"类型(小类)",
            downType:false,
            downText:"全部",
            mouseColor:"",
            list:[],
            idType:[],
          },
          {
            name:"是否预警",
            downType:false,
            downText:"全部",
            mouseColor:"",
            list:["全部","是","否",],
            idType:["","1","0"],
          },
        ],
      }
    },
    created(){

    },
    mounted() {
      this.listOrganization();
    },
    methods: {
      //点击查询
      clickQuery(){
        this.currentPage = 1;
        this.getListData();
      },
      //仓库
      async listOrganization () {
        let self = this;
        const { data } = await listOrganization();
        if(data.code==200){
          let list = [];
          let idType = [];
          list.push("全部");
          idType.push("");
          for(let i=0;i<data.data.length;i++){
            list.push(data.data[i].deptName);
            idType.push(data.data[i].deptId);
          }
          self.downList[0].list = JSON.parse(JSON.stringify(list));
          self.downList[0].idType = JSON.parse(JSON.stringify(idType));
          self.typeBig();
        }
      },
      //大类
      async typeBig () {
        let self = this;
        const { data } = await typeBig();
        if(data.code==200){
          let list = [];
          let idType = [];
          list.push("全部");
          idType.push("");
          for(let i=0;i<data.data.length;i++){
            list.push(data.data[i].bigTypeName);
            idType.push(data.data[i].id);
          }
          self.downList[1].list = JSON.parse(JSON.stringify(list));
          self.downList[1].idType = JSON.parse(JSON.stringify(idType));
          self.typeSmall();
        }
      },
      //小类
      async typeSmall () {
        let self = this;
        const { data } = await typeSmall();
        if(data.code==200){
          let list = [];
          let idType = [];
          list.push("全部");
          idType.push("");
          for(let i=0;i<data.data.length;i++){
            list.push(data.data[i].smallTypeName);
            idType.push(data.data[i].id);
          }
          self.downList[2].list = JSON.parse(JSON.stringify(list));
          self.downList[2].idType = JSON.parse(JSON.stringify(idType));
          self.getListData();
        }
      },
      //数据列表
      async getListData () {
        let self = this;
        let obj={
          materialName:self.inputData,
          pageSize:self.pagesize,
          pageNum:self.currentPage,
        };
        for(let i=0;i<self.downList[0].list.length;i++){
          if(self.downList[0].downText==self.downList[0].list[i]){
            obj.repertoryId = self.downList[0].idType[i];
          }
        }
        for(let i=0;i<self.downList[1].list.length;i++){
          if(self.downList[1].downText==self.downList[1].list[i]){
            obj.bigTypeId = self.downList[1].idType[i];
          }
        }
        for(let i=0;i<self.downList[2].list.length;i++){
          if(self.downList[2].downText==self.downList[2].list[i]){
            obj.smallTypeId = self.downList[2].idType[i];
          }
        }
        for(let i=0;i<self.downList[3].list.length;i++){
          if(self.downList[3].downText==self.downList[3].list[i]){
            obj.isWarning = self.downList[3].idType[i];
          }
        }
        const { data } = await statisticsAnalysisStocklistList(obj);
        if(data.code==200){
          this.tableData = data.rows;
          this.total = data.total;
          this.$forceUpdate();
        }
      },
      //下拉菜单进入悬浮状态
      colorTypeEnter(type,item){
        this.downList[type].mouseColor=item;
      },
      //下拉菜单离开悬浮状态
      colorTypeLeave(type){
        this.downList[type].mouseColor = "";
      },
      // 下拉菜单选项悬浮事件
      dropdownClickOpen(type,state){
        if(state==1){
          this.downList[type].downType = true
        }else if(state==2){
          this.downList[type].downType = false
        }
      },
      // 下拉菜单点击事件
      dropdownClick(type,item){
        this.downList[type].downText = item;
        this.downList[type].downType = false;
      },
      //表格绑定ID
      getRowKey (row) {
        return row.id
      },
      indexMethod(index) {
        return (this.currentPage-1)*this.pagesize+index+1;
      },
      //翻页
      handleCurrentChange(val) {
        console.log(`当前页: `,val);
        this.currentPage = val;
        this.getListData();
      },
    }
  }
</script>

<style scoped lang="stylus">
  .max-big-box
    display flex
    flex-direction column
    flex:1;
    .big-max-box
      display flex
      flex-direction column
      flex:1;
      //搜索与操作按钮
      .top-box
        height:30px;
        margin-top:20px;
        .input-box
          width:1700px;
          height:30px;
          display flex
          margin-left:105px;
          .search-input
            height:28px;
            width:290px;
            border:1px solid $theme;
            padding-left:10px;
          .dropdown-box
            display flex
            color:$color_ff;
            z-index:1;
            margin-left:30px;
            .dropdown-left-title
              line-height:30px;
              font-size:$font_14;
            .dropdown-right-box
              font-size:$font_12;
              .dropdown-text
                width:160px;
                height:30px;
                line-height:30px;
                background:url("~@/assets/images/button_15.png");
                background-size:100% 100%;
              .dropdown-for-max
                background:$backColor1;
                border-bottom-right-radius 4px
                border-bottom-left-radius 4px
                p
                  width:160px;
                  height:30px;
                  line-height:30px;
                .color-A
                  /*
                  background:$backColor2 !important;
                  color:$color_ff !important;
                  */
                  color:$theme !important;
                  border-bottom-right-radius 4px
                  border-bottom-left-radius 4px
          .button-box
            margin-left:32px;
            display flex
            height:30px;
            width:80px;
            background:url("~@/assets/images/button_03.png");
            background-size:100% 100%;
            img
              display block
              height:20px;
              width:20px;
              margin:5px 6px 0 13px;
            p
              line-height:30px;
              font-size:$font_12;
              color:$color_ff;
      //表格
      .table-box
        width:1710px !important;
        margin:20px 105px;
        text-align center !important
        .colorA
          color:$theme3;
      //时间日历
      .time-max-big-box
        z-index 6
        height:100%;
        width:100%;
        position: absolute
        top:0;
        left:0;
        background:rgba(0,0,0,0.3);
        .time-big-box
          z-index 6
          height:750px;
          width:660px;
          position: absolute
          top:50%;
          left:50%;
          transform :translate3d(-50%,-50%,0)
          margin:auto;
          background $color_ff
          border-radius:8px;
          border:4px solid $theme;
          .button-box
            display flex
            color:$color_ff;
            width:260px;
            margin:20px auto;
            p:nth-child(1)
              height:30px;
              line-height:30px;
              width:120px;
              background:url("~@/assets/images/button_10.png");
              background-size 100% 100%
            p:nth-child(2)
              margin-left:20px;
              height:30px;
              line-height:30px;
              width:120px;
              background:url("~@/assets/images/button_05.png");
              background-size 100% 100%
            p:nth-child(3)
              margin-left:20px;
              height:30px;
              line-height:30px;
              width:120px;
              background:url("~@/assets/images/button_02.png");
              background-size 100% 100%
    //修改日期选择样式
    /*
    .el-calendar
      background $color_ff
    */
    //修改table表格样式
    .el-table
      background rgba(6,177,240,0.2)
    .el-table /deep/ .el-table__empty-text
      width: 100%;
      text-align left
      margin-left:825px;
    .el-table /deep/ .el-table__body-wrapper::-webkit-scrollbar
      width: 4px;     /*高宽分别对应横竖滚动条的尺寸*/
      height: 4px;
    .el-table /deep/ .el-table__body-wrapper::-webkit-scrollbar-thumb
      border-radius: 5px;
      -webkit-box-shadow: inset 0 0 5px $theme;
      background: $theme;
    .el-table /deep/ .el-table__body-wrapper::-webkit-scrollbar-track
      -webkit-box-shadow: inset 0 0 5px rgba(255,255,255,0);
      border-radius: 0;
      background: rgba(255,255,255,0);
    .el-table /deep/ tr
    .el-table /deep/ th
      background rgba(6,177,240,0)
    .el-table::before
      height:0;
    .el-table /deep/ .cell
      max-height:46px;
      display: -webkit-box;
      -webkit-box-orient: vertical;
      -webkit-line-clamp: 2;
      overflow: hidden;
    .el-table /deep/ td
    .el-table /deep/ th.is-leaf
      border-bottom:0!important;
    .el-table /deep/ .el-checkbox__inner
      //background rgba(6,177,240,0.2)
      border 1px solid #216f93 !important
    .el-table /deep/ thead
      color:$color_ff;
    .el-table
      color:$color_a1
    .el-table /deep/ th
      text-align-last: center;
    .el-table /deep/ td
      text-align-last: center;
    .el-table /deep/ tbody tr:hover > td
      background rgba(6,177,240,0.2)
      color:$theme;
    .el-table /deep/ .el-checkbox
      width:14px;
      margin:0 auto;
      display block
    //修改动作条样式
    .el-pagination.is-background /deep/ .btn-next
    .el-pagination.is-background /deep/ .btn-prev
    .el-pagination.is-background /deep/ .el-pager li
      background:url("~@/assets/images/button_13.png");
      color:$color_ff;
    .el-pagination.is-background /deep/ .el-pager li:not(.disabled).active
      background:url("~@/assets/images/button_14.png");
      color:$color_ff;
    .colorA
      color :$theme;
    ::-webkit-input-placeholder
      color: $border_1;
    ::-moz-placeholder
      color: $border_1;
    ::-ms-input-placeholder
      color: $border_1;

</style>
